// exe_export.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <ole2.h>

IDispatch *IDisp;

BSTR __stdcall ExportedFunction1(LPSTR pszString){

	printf("\n\nInside VC EXE Exported Function 1 called from VB app via DeclareFx mechanism");
	printf("\nReceived arg: '%s'", pszString);
	
	char *x = "Some return Value";
	return SysAllocString((const unsigned short*) x);
}


int InitVBObject(void){

	 CLSID      clsid;
	 HRESULT	   hr;
	
     LPOLESTR   p = OLESTR("VbDllSample.CTest");
	
	 printf("\nInitilizing COM library for thread");
     hr = CoInitialize(NULL);

	 printf("\nGetting Clsid Struc from string name");
	 hr = CLSIDFromProgID( p , &clsid);

	 if( hr != S_OK  ){
		 printf("\nFailed to get Clsid from string");
		 return 1;
	 }

	 printf("\nCreating Instance of Specified Clsid");
	 // create an instance and get IDispatch pointer
	 hr =  CoCreateInstance( clsid,
							 NULL,
							 CLSCTX_INPROC_SERVER,
							 IID_IDispatch  ,
							 (void**) &IDisp
						   );

	 if ( hr != S_OK )
	 {
	   printf("\nCoCreate failed");
	   return 1;
	 }

	 return 0;

}

int CallNoArgVBMethod(){
	 
	 OLECHAR  *sMethodName = OLESTR("ShowSomeUI");
	 DISPID   dispid; // long integer containing the dispatch ID
	 HRESULT  hr;

	 printf("\nGetting the Dispatch ID for the method name");

	 hr=IDisp->GetIDsOfNames(IID_NULL,&sMethodName,1,LOCALE_USER_DEFAULT,&dispid);
	 
	 if( FAILED(hr) ){
	    printf("GetIDSOfNames failed");
		return 1;
	 }

	 DISPPARAMS dispparams;
	 VARIANTARG vararg[1]; //function takes no arguments
	 VARIANT    retVal;

	 VariantInit(&vararg[0]);
	 dispparams.rgvarg = &vararg[0];
	 dispparams.cArgs = 0;  // num of args function takes
	 dispparams.cNamedArgs = 0;

	 printf("\nInvoking the method...");
	 hr=IDisp->Invoke( dispid, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &dispparams, &retVal, NULL, NULL);
	
	 printf("\n\nBack From IDisp->Invoke..Releasing Reference\n\n");
	 IDisp->Release();

	 return 0;
}



int main(int argc, char* argv[])
{
	printf("Starting demo...\n");

	if( InitVBObject() == 0 )	CallNoArgVBMethod();

	CoUninitialize();
	return 0;
}